function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

(function (global, factory) {
  (typeof exports === "undefined" ? "undefined" : _typeof(exports)) === 'object' && typeof module !== 'undefined' ? module.exports = factory() : typeof define === 'function' && define.amd ? define(factory) : (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global['segi-tool-envpipe'] = factory());
})(this, function () {
  'use strict';
  /*
   * @Author: zuley
   * @Date: 2021-06-01 17:28:44
   * @LastEditors: zuley
   * @LastEditTime: 2021-06-09 13:43:02
   */

  var EnvPipe = /*#__PURE__*/function () {
    function EnvPipe() {
      _classCallCheck(this, EnvPipe);

      _defineProperty(this, "envList", {});

      _defineProperty(this, "config", []);

      _defineProperty(this, "actEnvName", 'default');
    }

    _createClass(EnvPipe, [{
      key: "defaultPipe",
      value: // 默认函数
      function defaultPipe() {
        console.log('没有设置默认管道方法');
        return null;
      } // 推入函数

    }, {
      key: "push",
      value: function push(env) {
        if (this.envList[env.name]) {
          console.log("".concat(env.name, " \u73AF\u5883\u91CD\u590D\uFF0C\u8BF7\u68C0\u67E5 PUSH \u7684\u53C2\u6570"));
          return;
        }

        if (!env.name.includes(":") && !env.complete) {
          console.log("".concat(env.name, " \u57FA\u5EA7\u73AF\u5883\u7F3A\u5C11 complete "));
          return;
        }

        this.envList[env.name] = env;
      } // 启动函数

    }, {
      key: "start",
      value: function () {
        var _start = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(config) {
          var actMainPipe, actMainData, actChildPipe;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  // return new Promise(res => {
                  this.config = config; // 获取当前基座环境管道

                  actMainPipe = this.getMainPipe(); // 如果匹配不了则执行默认管道

                  if (actMainPipe) {
                    _context.next = 7;
                    break;
                  }

                  this.actEnvName = "default";
                  _context.next = 6;
                  return this.defaultPipe();

                case 6:
                  return _context.abrupt("return", _context.sent);

                case 7:
                  this.actEnvName = actMainPipe.name;
                  _context.next = 10;
                  return actMainPipe.complete();

                case 10:
                  actMainData = _context.sent;
                  actChildPipe = this.getChildPipe(actMainPipe.name); // 没有子管道则直接执行管道

                  if (actChildPipe) {
                    _context.next = 14;
                    break;
                  }

                  return _context.abrupt("return", actMainData);

                case 14:
                  // 有子管道则执行主管道后传入子管道继续执行
                  this.actEnvName = actChildPipe.name;

                  if (!actChildPipe.complete) {
                    _context.next = 21;
                    break;
                  }

                  _context.next = 18;
                  return actChildPipe.complete(actMainData);

                case 18:
                  _context.t0 = _context.sent;
                  _context.next = 22;
                  break;

                case 21:
                  _context.t0 = actMainData;

                case 22:
                  return _context.abrupt("return", _context.t0);

                case 23:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function start(_x) {
          return _start.apply(this, arguments);
        }

        return start;
      }() // 获取当前基座环境管道

    }, {
      key: "getMainPipe",
      value: function getMainPipe() {
        var _iterator = _createForOfIteratorHelper(this.config),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var envName = _step.value;
            var env = this.envList[envName];
            if (env && env.in()) return env;
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }

        return null;
      } // 获取当前基座子管道环境

    }, {
      key: "getChildPipe",
      value: function getChildPipe(envName) {
        var _this = this;

        return this.envList[Object.keys(this.envList).find(function (env) {
          return env.includes("".concat(envName, ":")) && _this.envList[env].in();
        }) || ''];
      }
      /**
       * 获取环境名称字典表
       * @param envName 环境名称使用冒号 ： 隔开，前面是所处环境，后面是子环境
       * @returns 返回环境名称字典表
       */

    }, {
      key: "getEnvNameDict",
      value: function getEnvNameDict(envName) {
        var arr = envName.split(":");
        return {
          env: arr[0],
          child: arr[1] || null
        };
      }
      /**
       * 判断当前所处环境
       * @param envName 不使用冒号则只判断主环境，使用冒号则判断子环境
       * @returns 布尔值
       */

    }, {
      key: "isEnv",
      value: function isEnv(envName) {
        var EnvDict = this.getEnvNameDict(envName);
        var actEvnDict = this.getEnvNameDict(this.actEnvName); // 如果需要判断子环境，则直接比对 envName

        if (EnvDict.child) return envName === this.actEnvName; // 如果不需要判断子环境，则获取字典后直接比对 env

        return EnvDict.env === actEvnDict.env;
      }
      /**
       * 运行函数，匹配环境后执行对应的回调函数
       * @param envName 环境名称
       * @param fn 回调函数
       */

    }, {
      key: "run",
      value: function run(envName, fn) {
        if (this.isEnv(envName)) fn();
      }
    }]);

    return EnvPipe;
  }();

  return EnvPipe;
});
